'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _babylon = require('babylon');

var _s2sUtils = require('s2s-utils');

var _flowFaker = require('flow-faker');

var INITIAL_STATE = 'initialState';

exports.default = function () {
  return {
    inherits: _s2sUtils.inheritsOpts,
    name: 's2s-initial-state-creater',
    visitor: {
      Program: function Program(programPath, state) {
        var from = state.opts.from;

        programPath.traverse({
          VariableDeclarator: function VariableDeclarator(nodePath) {
            var idPath = nodePath.get('id');

            if (idPath.node.name !== INITIAL_STATE) {
              return;
            }

            var _nodePath$get$get$nod = nodePath.get('loc').get('start').node,
                line = _nodePath$get$get$nod.line,
                column = _nodePath$get$get$nod.column;

            var flowInfo = (0, _flowFaker.flowFakerSync)(from, {
              row: line,
              column: column + 1
            });

            var newAST = (0, _babylon.parseExpression)(JSON.stringify(flowInfo), {
              plugins: ['flow']
            });

            nodePath.get('init').replaceWith(newAST);
          }
        });
      }
    }
  };
};